var AjaxModalWidget = function (options) {
    var pageOptions = $.extend({
        id: null,
        pageSlug: null,
        url: null,
        postProcessTextJSCallback: null
    }, options, true);

    let registry = {};
    let id = '#' + pageOptions.id;

    $('body').on('shown.bs.modal', id, function () {
        if (pageOptions.pageSlug) {
            if (!registry[id]) {
                LandingCore.blockUI().block(id + ' .modal-content');
                $.ajax({
                    url: pageOptions.url + '?slug=' + pageOptions.pageSlug,
                    success: function (response) {
                        let pageHtml = response;

                        if(typeof pageOptions.postProcessTextJSCallback === 'function') {
                            pageHtml = pageOptions.postProcessTextJSCallback(pageHtml);
                        }

                        $(id).find('.modal-body').html(pageHtml);
                        LandingCore.blockUI().unblock(id + ' .modal-content');
                        Bootstrap4Migration();
                        registry[id] = true;
                    }
                });
            }
        }
    });
};